
/* dranduniform_secrng Example Program Text */
/*
 * Copyright (C) 2017-2018 Advanced Micro Devices, Inc. All rights reserved.
 */

#include <rng.h>
#include <stdio.h>
#include <stdlib.h>

int main(void)
{
#define MN 12
  const int mn=MN;
  double a, b;
  int genid, i, info, lstate, n, subid;
  double x[MN];
  int  *state;
  printf("--RNG-example: uniform random numbers using dranduniform_secrng--\n");
  printf("----------------------------------------------------------\n");
  printf("\n");

  /* Initialize the number of variates required */
  n = mn;

  /* Use the MT generator as the base generator */
  genid = 3;
  subid = 1;

  lstate = 0;

  /* Initialize the base generator */
  drandinitialize_secrng(genid,subid,state,&lstate,&info);

  /* Allocate memory for state */
  if (!(state = (int *) malloc(sizeof(int) * lstate))) {
    printf("Error, could not allocate memory\n");
    exit(1);
  }

 /* Initialize the base generator */
  drandinitialize_secrng(genid,subid,state,&lstate,&info);

  /* Generate a sequence from a uniform U(0,1) distribution */
  a = 0.0;
  b = 1.0;
  dranduniform(n,a,b,state,x,&info);

  /* Print the sequence */
  printf("Numbers from a uniform U(0,1) distribution:\n");
  for (i=0; i<n; i++)
    {
      printf("%10.4f", x[i]);
      if ((i+1)%4 == 0)
        printf("\n");
    }
  printf("\n");
  return 0;
}
