/*

(C) 2008-2020 Advanced Micro Devices, Inc. All Rights Reserved.

Advanced Micro Devices, Inc.
Software License Agreement

IMPORTANT-READ CAREFULLY:  Do not load or use the Software until you have
carefully read and agreed to the following terms and conditions.  This is a
legal agreement ("Agreement") between you (either an individual or an entity)
("Licensee") and Advanced Micro Devices, Inc. ("AMD"). If Licensee does not
agree to the terms of this Agreement, do not install or use this software or
any portion thereof.  By loading or using the object code version only of the
software obtained herewith, which may include associated install scripts and
online or electronic documentation or any portion thereof, that is made
available by AMD to download from any media ("Software"), Licensee agrees to
all of the terms of this Agreement.

1.  LICENSE:

    a.  Subject to the terms and conditions of this Agreement, AMD grants
    Licensee the following non-exclusive, non-transferable, royalty-free,
    limited copyright license to download, copy, use, distribute and sublicense
    the foregoing rights through multiple tiers of sublicenses the object code
    version of the Software and materials associated with this Agreement,
    including without limitation printed documentation, (collectively,
    "Materials"), provided that Licensee agrees to include all copyright
    legends and other legal notices that may appear in the Materials.  The
    foregoing license is conditioned upon Licensee distributing the object code
    version of the Software only and under this software license agreement.
    Except for the limited license granted herein, Licensee shall have no other
    rights in the Materials, whether express, implied, arising by estoppel or
    otherwise.

    b.  Except as expressly set forth in Section 1(a), Licensee does not have
    the right to (i) distribute, rent, lease, sell, sublicense, assign, or
    otherwise transfer the Materials, in whole or in part, to third parties for
    commercial or for non-commercial use; or (ii) modify, disassemble, reverse
    engineer, or decompile the Software, or otherwise reduce any part of the
    Software to any human readable form.  All rights in and to the Materials
    not expressly granted to Licensee in this Agreement are reserved to AMD.

2.  FEEDBACK:  Licensee may provide AMD feedback, suggestions or opinions as to
the Software, its features, and desired enhancements or changes.  If Licensee
provides feedback, suggestions or opinions to AMD regarding any new features,
use, functionality, or change to the Software or any materials related to the
Software, Licensee hereby agrees to grant, and does grant, AMD all rights
needed for AMD to incorporate, modify, distribute, use and commercialize any
new feature, use, functionality, or change at no charge or encumbrance to AMD.
Licensee agrees that AMD may disclose such feedback, suggestions or opinions to
any third party in any manner, and Licensee agrees that AMD has the ability to
sublicense any of the foregoing rights in any feedback, suggestions or opinions
or AMD products or services in any form to any third party without restriction.

3.  OWNERSHIP AND COPYRIGHT OF MATERIALS: Licensee agrees that the Materials
are owned by AMD and are protected by United States and foreign intellectual
property laws (e.g. patent and copyright laws) and international treaty
provisions.  Licensee will not remove the copyright notice from the Materials.
Licensee agrees to prevent any unauthorized copying of the Materials.  All
title and copyrights in and to the Materials, all copies thereof (in whole or
in part, and in any form), and all rights therein shall remain vested in AMD.
Except as expressly provided herein, AMD does not grant any express or implied
right to Licensee under AMD patents, copyrights, trademarks, or trade secret
information.

4.  WARRANTY DISCLAIMER: THE MATERIALS ARE PROVIDED "AS IS" WITHOUT ANY EXPRESS
OR IMPLIED WARRANTY OF ANY KIND INCLUDING WARRANTIES OF MERCHANTABILITY,
NONINFRINGEMENT OF THIRD-PARTY INTELLECTUAL PROPERTY, TITLE, OR FITNESS FOR ANY
PARTICULAR PURPOSE, OR THOSE ARISING FROM CUSTOM OF TRADE OR COURSE OF USAGE.
THE ENTIRE RISK ARISING OUT OF USE OR PERFORMANCE OF THE MATERIALS REMAINS WITH
LICENSEE.  AMD DOES NOT WARRANT, GUARANTEE, OR MAKE ANY REPRESENTATIONS AS TO
THE CORRECTNESS, ACCURACY, COMPLETENESS, QUALITY, OR RELIABILITY OF THE
MATERIALS.

AMD DOES NOT WARRANT THAT OPERATION OF THE MATERIALS WILL BE UNINTERRUPTED OR
ERROR-FREE.  YOU ARE RESPONSIBLE FOR DETERMINING THE APPROPRIATENESS OF USING
THE SOFTWARE AND ASSUME ALL RISKS ASSOCIATED WITH THE USE OF THE MATERIALS,
INCLUDING BUT NOT LIMITED TO THE RISKS OF PROGRAM ERRORS, DAMAGE TO OR LOSS OF
DATA, PROGRAMS OR EQUIPMENT, AND UNAVAILABILITY OR INTERRUPTION OF OPERATIONS.
SOME JURISDICTIONS DO NOT ALLOW FOR THE EXCLUSION OR LIMITATION OF IMPLIED
WARRANTIES, SO THE ABOVE LIMITATIONS OR EXCLUSIONS MAY NOT APPLY TO LICENSEE.

5.  LIMITATION OF LIABILITY:  IN NO EVENT SHALL AMD OR ITS DIRECTORS, OFFICERS,
EMPLOYEES AND AGENTS, ITS SUPPLIERS OR ITS LICENSORS BE LIABLE TO LICENSEE OR
ANY THIRD PARTIES IN RECEIPT OF THE MATERIALS FOR CONSEQUENTIAL, INCIDENTAL,
PUNITIVE OR SPECIAL DAMAGES, INCLUDING, BUT NOT LIMITED TO LOSS OF PROFITS,
BUSINESS INTERRUPTION, OR LOSS OF INFORMATION ARISING OUT OF THE USE OF OR
INABILITY TO USE THE MATERIALS, EVEN IF AMD HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.  AMD DOES NOT ASSUME ANY RESPONSIBILITY TO SUPPORT OR UPDATE
THE MATERIALS.  BY USING THE MATERIALS WITHOUT CHARGE, YOU ACCEPT THIS
ALLOCATION OF RISK.  BECAUSE SOME JURSIDICTIONS PROHIBIT THE EXCLUSION OR
LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE ABOVE
LIMITATION MAY NOT APPLY TO LICENSEE.

6.  U.S. GOVERNMENT RESTRICTED RIGHTS: The Materials are provided with
"RESTRICTED RIGHTS."  Use, duplication or disclosure by the Government is
subject to restrictions as set forth in FAR52.227-14 and DFAR252.227-7013, et
seq., or its successor.  Use of the Materials by the Government constitutes
acknowledgment of AMD's proprietary rights in them.

7.  TERMINATION OF LICENSE: This Agreement will terminate immediately without
notice from AMD or judicial resolution if Licensee fails to comply with any
provisions of this Agreement.  Upon termination of this Agreement, Licensee
must delete or destroy all copies of the Materials.

8.  SUPPORT.  Under this Agreement, AMD is under no obligation to assist in the
use of the Materials, to provide support to licensees of the Materials, or to
provide maintenance, correction, modification, enhancement, or upgrades to the
Materials.  If AMD determines, in its sole discretion, to support, maintain,
correct, modify, enhance, or upgrade the Software, such support, maintenance,
correction, modification, enhancement or upgrade shall be considered part of
the Materials, and shall be subject to this Agreement.

9.  SURVIVAL:  Sections 1(b), 2, 3, 4, 5, 6, and 8 through 14 shall survive any
expiration or termination of this Agreement.

10. APPLICABLE LAWS:  Any claim arising under or relating to this Agreement
shall be governed by and construed in accordance with the substantive laws of
the State of California, without regard to principles of conflict of laws.
Each party hereto submits to the jurisdiction of the state and federal courts
of Santa Clara County and the Northern District of California for the purposes
of all legal proceedings arising out of or relating to this Agreement or the
subject matter hereof.  Each party waives any objection which it may have to
contest such forum.

11. IMPORT/EXPORT/RE-EXPORT/USE/RELEASE/TRANSFER RESTRICTIONS AND COMPLIANCE
WITH LAWS:  Licensee is hereby provided notice, and agrees and acknowledges,
that the Software, its source code, any accompanying media, material or
information, and any product of the foregoing, may be subject to restrictions
on use, release, transfer, importation, exportation and/or re- exportation
under the laws and regulations of the United States or other countries
("Applicable Laws"), which include but are not limited to U.S. export control
laws such as the Export Administration Regulations and national security
controls as defined thereunder, as well as State Department controls under the
U.S. Munitions List.  Licensee further agrees that the Software, its source
code, any accompanying media, material or information, and any product of the
foregoing, will not be used, released, transferred, imported, exported and/or
re-exported in any manner prohibited under Applicable Laws, including U.S.
export control laws regarding specifically designated persons, countries and
nationals of countries subject to national security controls as provided in
License Exception TSR of the Export Administration Regulations and any
successor regulations.

12. SEVERABILITY:  Should any term of this Agreement be declared void or
unenforceable by any court of competent jurisdiction, such declaration shall
have no effect on the remaining terms hereof.

13. NO WAIVER:  The failure of either party to enforce any rights granted
hereunder or to take action against the other party in the event of any breach
hereunder shall not be deemed a waiver by that party as to subsequent
enforcement of rights or subsequent actions in the event of future breaches.

14. ENTIRE AGREEMENT:  This Agreement constitutes the entire agreement between
the parties and supersedes any prior or contemporaneous oral or written
agreements with respect to the subject matter of this Agreement.

*/


#include <emmintrin.h>
#include <immintrin.h>

#ifdef AMD_LIBM_VEC_EXTERNAL_H
#define AMD_LIBM_VEC_EXTERNAL_H

/*
 * We don’t expect anyone to include this file directly.
* but rely on AOCC to generate appropriate calls to vector functions
*/

#ifndef AMD_LIBM_VEC_EXPERIMENTAL
#error "The functionality in this header is experimental, please define AMD_LIBM_VEC_EXPERIMENTAL"
#endif /* EXPERIMENTAL */

#ifdef __cplusplus
extern "C" {
#endif

 /* Exponential */

    __m128d amd_vrd2_exp    (__m128d x);
    __m128  amd_vrs4_expf   (__m128  x);
    __m128d amd_vrd2_exp2   (__m128d x);
    __m128  amd_vrs4_exp2f  (__m128  x);
    __m128d amd_vrd2_exp10  (__m128d x);
    __m128  amd_vrs4_exp10f (__m128  x);
    __m128d amd_vrd2_expm1  (__m128d x);
    __m128  amd_vrs4_expm1f (__m128  x);

    __m256d amd_vrd4_exp (__m256d);
    __m256  amd_vrs8_expf (__m256);

    void amd_vrda_exp       (int len, double *src, double *dst);
    void amd_vrsa_expf      (int len, float  *src, float  *dst);
    void amd_vrda_exp2      (int len, double *src, double *dst);
    void amd_vrsa_exp2f     (int len, float  *src, float  *dst);
    void amd_vrda_exp10     (int len, double *src, double *dst);
    void amd_vrsa_exp10f    (int len, float  *src, float  *dst);
    void amd_vrda_expm1     (int len, double *src, double *dst);
    void amd_vrsa_expm1f    (int len, float  *src, float  *dst);


 /* Logarithmic */

    __m128d amd_vrd2_log    (__m128d x);
    __m128  amd_vrs4_logf   (__m128  x);
    __m128d amd_vrd2_log2   (__m128d x);
    __m128  amd_vrs4_log2f  (__m128  x);
    __m128d amd_vrd2_log10  (__m128d x);
    __m128  amd_vrs4_log10f (__m128  x);
    __m128d amd_vrd2_log1p  (__m128d x);
    __m128  amd_vrs4_log1pf (__m128  x);

    __m256d amd_vrd4_log (__m256d);
    __m256  amd_vrs8_logf (__m256);

    void amd_vrda_log       (int len, double *src, double *dst);
    void amd_vrsa_logf      (int len, float  *src, float  *dst);
    void amd_vrda_log2      (int len, double *src, double *dst);
    void amd_vrsa_log2f     (int len, float  *src, float  *dst);
    void amd_vrda_log10     (int len, double *src, double *dst);
    void amd_vrsa_log10f    (int len, float  *src, float  *dst);
    void amd_vrda_log1p     (int len, double *src, double *dst);
    void amd_vrsa_log1pf    (int len, float  *src, float  *dst);

/* Trigonometric */

    __m128d amd_vrd2_cos    (__m128d x);
    __m128  amd_vrs4_cosf   (__m128  x);
    __m128d amd_vrd2_sin    (__m128d x);
    __m128  amd_vrs4_sinf   (__m128  x);

    void amd_vrda_cos       (int len, double *src, double *dst);
    void amd_vrsa_cosf      (int len, float  *src, float  *dst);
    void amd_vrda_sin       (int len, double *src, double *dst);
    void amd_vrsa_sinf      (int len, float  *src, float  *dst);


 /* Power */

    __m128d amd_vrd2_cbrt   (__m128d x);
    __m128d amd_vrd2_pow    (__m128d x, __m128d y);
    __m128  amd_vrs4_cbrtf  (__m128  x);
    __m128  amd_vrs4_powf   (__m128 x, __m128 y);

    __m256d amd_vrd4_pow (__m256d, __m256d);
    __m256  amd_vrs8_powf (__m256, __m256);

    void amd_vrda_cbrt      (int len, double *src, double *dst);
    void amd_vrsa_cbrtf     (int len, float  *src, float  *dst);
    void amd_vrsa_powf      (int len, float *src1, float *src2, float* dst);

#ifdef __cplusplus
}
#endif

#endif /* AMD_\LIBM_VEC_EXTERNAL */
